package com.objis.spring.dao.hibernate;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Repository;

import com.objis.spring.dao.IEmployeDao;

import domaine.Employe;

import domaine.Employe;

/*
 * Version d'HibernateEmployeDAO en utilisant un Template Hibernate
 * Avantage : services rendus par le Template (gestion exceptions, API bas niveau...)
 * Inconvenient : code spring intrusif
 */
public class HibernateEmployeDao implements IEmployeDao{

	private HibernateTemplate hibernateTemplate;
	/*
	 * Meilleure pratique utilisation HibernateTemplate dans un DAO:
	 * La Hibernate Template est injecte au DAO lors de la cration de ce dernier . 
	 * Paramtrage ralis dans spring-data.xml
	 */
	public void setHibernateTemplate(HibernateTemplate template) {
	    this.hibernateTemplate = template;
	}
	
	public void saveEmploye(Employe employe) {
		hibernateTemplate.saveOrUpdate(employe);
	}

	public Employe getEmployeById(int id) {
		List results = hibernateTemplate.find("from Employe where id =" + id);
		return results.size() > 0 ? (Employe) results.get(0) : null;
	}

	public List<Employe> getAllEmployes() {
		// TODO Auto-generated method stub
		return null;
	}

	public Employe getEmployeByLogin(String login) {
		// TODO Auto-generated method stub
		return null;
	}

	public int getEmployesCount() {
		// TODO Auto-generated method stub
		return 0;
	}

}
